#region Copyright Syncfusion Inc. 2001 - 2012
//
//  Copyright Syncfusion Inc. 2001 - 2012. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Any infringement will be prosecuted under
//  applicable laws. 
//
#endregion

using System;
using System.Drawing;
using System.Drawing.Imaging;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.IO;
using System.Diagnostics;

using Syncfusion.DocIO;
using Syncfusion.DocIO.DLS;

namespace EssentialDocIOSamples
{

    public class Form1 : System.Windows.Forms.Form
    {
        #region Private Members

        private ToolTip toolTip1;
        private Button button1;
        private PictureBox pictureBox1;
        private Label label2;
        private IContainer components;

        #endregion

        #region Constructor, Main and Dispose
        public Form1()
        {
            //
            // Required for Windows Form Designer support
            //
            InitializeComponent();
            Application.EnableVisualStyles();
            //
            // TODO: Add any constructor code after InitializeComponent call
            //
        }
        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main()
        {
            Application.Run(new Form1());
        }
        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                if (components != null)
                {
                    components.Dispose();
                }
            }
            base.Dispose(disposing);
        }
        #endregion

        #region Windows Form Designer generated code
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(Form1));
            this.toolTip1 = new System.Windows.Forms.ToolTip(this.components);
            this.button1 = new System.Windows.Forms.Button();
            this.pictureBox1 = new System.Windows.Forms.PictureBox();
            this.label2 = new System.Windows.Forms.Label();
            ((System.ComponentModel.ISupportInitialize)(this.pictureBox1)).BeginInit();
            this.SuspendLayout();
            // 
            // button1
            // 
            this.button1.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.button1.BackColor = System.Drawing.Color.Transparent;
            this.button1.FlatAppearance.BorderColor = System.Drawing.Color.FromArgb(((int)(((byte)(255)))), ((int)(((byte)(192)))), ((int)(((byte)(128)))));
            this.button1.FlatAppearance.MouseDownBackColor = System.Drawing.Color.FromArgb(((int)(((byte)(255)))), ((int)(((byte)(224)))), ((int)(((byte)(192)))));
            this.button1.FlatAppearance.MouseOverBackColor = System.Drawing.Color.FromArgb(((int)(((byte)(255)))), ((int)(((byte)(255)))), ((int)(((byte)(192)))));
            this.button1.Image = ((System.Drawing.Image)(resources.GetObject("button1.Image")));
            this.button1.ImageAlign = System.Drawing.ContentAlignment.MiddleRight;
            this.button1.Location = new System.Drawing.Point(484, 216);
            this.button1.Name = "button1";
            this.button1.Size = new System.Drawing.Size(96, 30);
            this.button1.TabIndex = 62;
            this.button1.Text = "Generate";
            this.button1.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            this.button1.UseVisualStyleBackColor = false;
            this.button1.Click += new System.EventHandler(this.button1_Click);
            // 
            // pictureBox1
            // 
            this.pictureBox1.Dock = System.Windows.Forms.DockStyle.Top;
            this.pictureBox1.Image = ((System.Drawing.Image)(resources.GetObject("pictureBox1.Image")));
            this.pictureBox1.Location = new System.Drawing.Point(0, 0);
            this.pictureBox1.Name = "pictureBox1";
            this.pictureBox1.Size = new System.Drawing.Size(589, 112);
            this.pictureBox1.TabIndex = 60;
            this.pictureBox1.TabStop = false;
            // 
            // label2
            // 
            this.label2.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(161)));
            this.label2.ForeColor = System.Drawing.SystemColors.ControlText;
            this.label2.Location = new System.Drawing.Point(8, 123);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(440, 51);
            this.label2.TabIndex = 68;
            this.label2.Text = "Click the button to view the Word document generated by Essential DocIO. Please n" +
    "ote that MS Word Viewer or MS Word is required to view the resultant document.";
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(6, 15);
            this.BackColor = System.Drawing.Color.White;
            this.ClientSize = new System.Drawing.Size(589, 371);
            this.Controls.Add(this.label2);
            this.Controls.Add(this.button1);
            this.Controls.Add(this.pictureBox1);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.MaximizeBox = false;
            this.Name = "Form1";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "Generate Word";
            ((System.ComponentModel.ISupportInitialize)(this.pictureBox1)).EndInit();
            this.ResumeLayout(false);

        }
        #endregion

        #region Button_Click Event
        private void button1_Click(object sender, System.EventArgs e)
        {    
            string mainFile= Application.StartupPath + @"\..\..\Data\A4.docx";
            string subFile = Application.StartupPath + @"\..\..\Data\A3.docx";

            //Loads an main Word document.
            WordDocument mainDocument = new WordDocument(mainFile);

            //Find the placeholder, where to insert contents of sub document.
            TextSelection selection =  mainDocument.Find("InsertBreak", true, true);
            WTextRange textRange = selection.GetAsOneRange();
            //Get the owner paragraph.
            WParagraph para = textRange.OwnerParagraph;
            
            //Get the ownner section and the paragraph index.
            WSection ownerSection = para.OwnerTextBody.Owner as WSection;
            int secIndex = mainDocument.Sections.IndexOf(ownerSection);
            int paraIndex = ownerSection.Body.ChildEntities.IndexOf(para);

            //Create new section.
            WSection section = new WSection(mainDocument);
            //Add section break to preserve in new page.
            section.BreakCode = SectionBreakCode.NewPage;
            //Insert new section to split contents as different sections.
            mainDocument.Sections.Insert(secIndex + 1, section);

            //Move all contents to new section.
            for (; ownerSection.Body.ChildEntities.Count > paraIndex + 1;)
            {
                section.Body.ChildEntities.Add(ownerSection.Body.ChildEntities[paraIndex]);
                section.PageSetup.DifferentOddAndEvenPages = ownerSection.PageSetup.DifferentOddAndEvenPages;
            }
            
            //Set header footer for each sections, to preserve properly after inserting document in the middle.
            SetHeaderFooters(mainDocument);


            //Loads an sub Word document.
            WordDocument subDocument = new WordDocument(subFile);
            
            secIndex++;
            //Insert all sections of sub Word document in between the section of Main Word document.
            foreach(WSection sec in subDocument.Sections)
            {
                mainDocument.Sections.Insert(secIndex, sec.Clone());
                //Set the properties from sub document to main document.
                //Here, you can set other page properties from sub Word document.
                mainDocument.Sections[secIndex].PageSetup.DifferentOddAndEvenPages = sec.PageSetup.DifferentOddAndEvenPages;
                //Increment the index to insert all sections.
                secIndex++;
            }

            //Saving the document as .docx
            mainDocument.Save("Sample.docx", FormatType.Docx);
            //Closes the Word document.
            mainDocument.Close();
            subDocument.Close();

            //Message box confirmation to view the created document.
            if (MessageBox.Show("Do you want to view the MS Word document?", "Document has been created", MessageBoxButtons.YesNo, MessageBoxIcon.Information) == DialogResult.Yes)
            {
                try
                {
                    //Launching the MS Word file using the default Application.[MS Word Or Free WordViewer]
                    System.Diagnostics.Process.Start("Sample.docx");
                    //Exit
                    this.Close();
                }
                catch (Win32Exception ex)
                {
                    Console.WriteLine(ex.ToString());
                }
            }
            // Exit
            this.Close();

        }
        #region Helper methods

        /// <summary>
        /// Set header and footer specific for each sections.
        /// </summary>
        /// <param name="mainDocument"></param>
        private void SetHeaderFooters(WordDocument mainDocument)
        {
            //Get headers and footer in main Word document.
            HeaderFooter evenHeader = mainDocument.Sections[0].HeadersFooters.EvenHeader;
            HeaderFooter evenFooter = mainDocument.Sections[0].HeadersFooters.EvenFooter;
            HeaderFooter oddHeader = mainDocument.Sections[0].HeadersFooters.OddHeader;
            HeaderFooter oddFooter = mainDocument.Sections[0].HeadersFooters.OddFooter;
            HeaderFooter firstPageHeader = mainDocument.Sections[0].HeadersFooters.FirstPageHeader;
            HeaderFooter firstPageFooter = mainDocument.Sections[0].HeadersFooters.FirstPageFooter;

            //Set the header footers for each sections.
            for (int i = 1; i < mainDocument.Sections.Count; i++)
            {
                MoveItems(mainDocument.Sections[i].HeadersFooters.EvenHeader.ChildEntities, evenHeader.ChildEntities);
                MoveItems(mainDocument.Sections[i].HeadersFooters.EvenFooter.ChildEntities, evenFooter.ChildEntities);
                MoveItems(mainDocument.Sections[i].HeadersFooters.OddHeader.ChildEntities, oddHeader.ChildEntities);
                MoveItems(mainDocument.Sections[i].HeadersFooters.OddFooter.ChildEntities, oddFooter.ChildEntities);
                MoveItems(mainDocument.Sections[i].HeadersFooters.FirstPageHeader.ChildEntities, firstPageHeader.ChildEntities);
                MoveItems(mainDocument.Sections[i].HeadersFooters.FirstPageFooter.ChildEntities, firstPageFooter.ChildEntities);
                //Disable link to previous as false, to preserve header and footers of corresponding sections.
                mainDocument.Sections[i].HeadersFooters.LinkToPrevious = false;
            }

        }
        /// <summary>
        /// Move all the items from one collection to another collection.
        /// </summary>
        /// <param name="childEntities1"></param>
        /// <param name="childEntities2"></param>
        private void MoveItems(EntityCollection childEntities1, EntityCollection childEntities2)
        {
            for (int i = 0; i < childEntities1.Count; i++)
                childEntities1.Add(childEntities2[i].Clone());
        }
        #endregion
#endregion

    }
}

